diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTerm.java
new file mode 100644
index 0000000000..a0092bb6e9
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTerm.java
@@ -0,0 +1,171 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.model.common;
+
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.UUID;
+
+import javax.persistence.Entity;
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.XmlType;
+
+import org.codehaus.plexus.util.StringUtils;
+import org.hibernate.envers.Audited;
+import org.hibernate.search.annotations.Indexed;
+
+import eu.etaxonomy.cdm.model.location.NamedArea;
+
+
+/**
+ * @author a.mueller
+ * @created 2013-06-19
+ *
+ */
+@XmlAccessorType(XmlAccessType.FIELD)
+@XmlType(name = "DefinedTerm")
+@XmlRootElement(name = "DefinedTerm")
+@Entity
+@Indexed(index = "eu.etaxonomy.cdm.model.common.DefinedTermBase")
+@Audited
+public class DefinedTerm extends DefinedTermBase<DefinedTerm> {
+	private static final long serialVersionUID = -6965540410672076893L;
+
+	//Determination modifier
+	public static final UUID uuidConfer = UUID.fromString("20db670a-2db2-49cc-bbdd-eace33694b7f");
+	public static final UUID uuidAffinis = UUID.fromString("128f0b54-73e2-4efb-bfda-a6243185a562");
+
+	//Sex
+	private static final UUID uuidMale = UUID.fromString("600a5212-cc02-431d-8a80-2bf595bd1eab");
+	private static final UUID uuidFemale = UUID.fromString("b4cfe0cb-b35c-4f97-9b6b-2b3c096ea2c0");
+	private static final UUID uuidHermaphrodite = UUID.fromString("0deddc65-2505-4c77-91a7-17d0de24afcc");
+	private static final UUID uuidUnknown = UUID.fromString("4f5e4c51-a664-48ad-8238-2e9f49eaf8dd");
+	
+	//Marker
+	private static final UUID uuidIts1 = UUID.fromString("3f2de4f6-d1a2-4c3a-be70-3c997ef92543");
+	
+	protected static Map<UUID, DefinedTerm> termMap = null;		
+	
+	
+	protected static DefinedTerm getTermByUuid(UUID uuid){
+		if (termMap == null){
+			return null;
+		}else{
+			return (DefinedTerm)termMap.get(uuid);
+		}
+	}
+
+	
+	public static DefinedTerm NewInstance(TermType termType, String description, String label, String labelAbbrev){
+		return new DefinedTerm(termType, description, label, labelAbbrev);
+	}
+
+	
+	public static DefinedTerm NewModifierInstance(String description, String label, String labelAbbrev){
+		return new DefinedTerm(TermType.Modifier, description, label, labelAbbrev);
+	}
+	
+	public static DefinedTerm NewStageInstance(String description, String label, String labelAbbrev){
+		return new DefinedTerm(TermType.Stage, description, label, labelAbbrev);
+	}
+	
+	public static DefinedTerm NewSexInstance(String description, String label, String labelAbbrev){
+		return new DefinedTerm(TermType.Sex, description, label, labelAbbrev);
+	}
+	
+	public static DefinedTerm NewScopeInstance(String description, String label, String labelAbbrev){
+		return new DefinedTerm(TermType.Scope, description, label, labelAbbrev);
+	}
+
+	public static DefinedTerm NewDnaMarkerInstance(String description, String label, String labelAbbrev){
+		return new DefinedTerm(TermType.DnaMarker, description, label, labelAbbrev);
+	}
+	
+		
+//******************* CONSTRUCTOR ***********************************/
+
+	//for hibernate/javassist use only
+	@Deprecated
+	protected DefinedTerm(){
+		super(TermType.Unknown);
+	};
+	
+	public DefinedTerm(TermType type, String description, String label, String labelAbbrev) {
+		super(type, description, label, labelAbbrev);
+	}
+
+//*************************** TERM MAP *********************/
+	
+	
+	public static final DefinedTerm DETERMINATION_MODIFIER_AFFINIS(){
+		return getTermByUuid(uuidAffinis);
+	}
+
+	public static final DefinedTerm DETERMINATION_MODIFIER_CONFER(){
+		return getTermByUuid(uuidConfer);
+	}
+	
+	public static DefinedTerm SEX_MALE(){
+		return getTermByUuid(uuidMale);
+	}
+
+	public static DefinedTerm SEX_FEMALE(){
+		return getTermByUuid(uuidFemale);
+	}
+	
+	public static DefinedTerm SEX_HERMAPHRODITE(){
+		return getTermByUuid(uuidHermaphrodite);
+	}
+	
+	public static DefinedTerm SEX_UNKNOWN(){
+		return getTermByUuid(uuidUnknown);
+	}
+
+	public static DefinedTerm ITS1_MARKER(){
+		return getTermByUuid(uuidIts1);
+	}
+	
+	
+	@Override
+	public void resetTerms() {
+		termMap = null;
+	}
+
+	@Override
+	protected void setDefaultTerms(TermVocabulary<DefinedTerm> termVocabulary) {
+		if (termMap == null){
+			termMap = new HashMap<UUID, DefinedTerm>();
+		}
+		for (DefinedTerm term : termVocabulary.getTerms()){
+			termMap.put(term.getUuid(), (DefinedTerm)term);  //TODO casting
+		}		
+	}
+
+	@Override
+	protected int partOfCsvLineIndex(){
+		return 5;
+	}
+
+//	@Override
+//	void readIsPartOf(DefinedTerm newInstance, List<String> csvLine, Map<UUID, DefinedTermBase> terms) {
+//        int index = 7;
+//		String partOfString = csvLine.get(index);
+//
+//        if(StringUtils.isNotBlank(partOfString)) {
+//            UUID partOfUuid = UUID.fromString(partOfString);
+//            DefinedTerm partOf = (DefinedTerm)terms.get(partOfUuid);
+//            partOf.addIncludes(newInstance);
+//        }
+//		
+//	}
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTermBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTermBase.java
index bfd18706f0..fd38a28137 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTermBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefinedTermBase.java
@@ -9,6 +9,7 @@
 
 package eu.etaxonomy.cdm.model.common;
 
+import java.lang.reflect.Constructor;
 import java.net.URI;
 import java.util.HashSet;
 import java.util.List;
@@ -36,14 +37,15 @@ import javax.xml.bind.annotation.XmlTransient;
 import javax.xml.bind.annotation.XmlType;
 
 import org.apache.log4j.Logger;
+import org.codehaus.plexus.util.StringUtils;
 import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
 import org.hibernate.envers.Audited;
 import org.hibernate.search.annotations.ClassBridge;
+import org.hibernate.validator.constraints.Length;
 
 import au.com.bytecode.opencsv.CSVWriter;
 import eu.etaxonomy.cdm.hibernate.search.DefinedTermBaseClassBridge;
-import eu.etaxonomy.cdm.model.agent.InstitutionType;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.MeasurementUnit;
 import eu.etaxonomy.cdm.model.description.StatisticalMeasure;
@@ -51,7 +53,7 @@ import eu.etaxonomy.cdm.model.description.TextFormat;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
 import eu.etaxonomy.cdm.model.location.ReferenceSystem;
 import eu.etaxonomy.cdm.model.media.Media;
-import eu.etaxonomy.cdm.model.media.RightsTerm;
+import eu.etaxonomy.cdm.model.media.RightsType;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
 import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
@@ -62,21 +64,21 @@ import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
  * use partOf relation and BreadthFirst. Default iterator order should therefore
  * be BreadthFirst (not DepthFirst)
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:19
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "DefinedTermBase", propOrder = {
     "media",
-    "vocabulary"
+    "vocabulary",
+    "idInVocabulary"
 })
 @XmlRootElement(name = "DefinedTermBase")
 @XmlSeeAlso({
     AnnotationType.class,
     DerivationEventType.class,
+    DefinedTerm.class,
     ExtensionType.class,
     Feature.class,
-    InstitutionType.class,
     Language.class,
     MarkerType.class,
     MeasurementUnit.class,
@@ -84,7 +86,7 @@ import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
     NomenclaturalCode.class,
     PreservationMethod.class,
     ReferenceSystem.class,
-    RightsTerm.class,
+    RightsType.class,
     StatisticalMeasure.class,
     TextFormat.class
 })
@@ -153,53 +155,251 @@ public abstract class DefinedTermBase<T extends DefinedTermBase> extends TermBas
     @ManyToOne(fetch=FetchType.LAZY)
     @Cascade(CascadeType.SAVE_UPDATE)
     protected TermVocabulary<T> vocabulary;
+    
+  //the unique tabel this term uses in its given vocabulary #3479
+   //open issues: is null allowed? If not, implement unique constraint
+    
+    @XmlElement(name = "idInVocabulary")
+    @Length(max=255)
+    private String idInVocabulary;  //the unique tabel this term uses in its given vocabulary #3479
 
 //***************************** CONSTRUCTOR *******************************************/
 
-    public DefinedTermBase() {
-        super();
+    //for javassit only
+    @Deprecated
+    protected DefinedTermBase(){};
+    
+    protected DefinedTermBase(TermType type) {
+        super(type);
     }
-    public DefinedTermBase(String term, String label, String labelAbbrev) {
-        super(term, label, labelAbbrev);
+    public DefinedTermBase(TermType type, String description, String label, String labelAbbrev) {
+        super(type, description, label, labelAbbrev);
     }
 
-//******************************* METHODS ******************************************************/
 
+//********************** GETTER /SETTER *************************************    
+    
+  	/* (non-Javadoc)
+  	 * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getIdInVocabulary()
+  	 */
+  	@Override
+  	public String getIdInVocabulary() {
+  		return idInVocabulary;
+  	}
+  	
+  	/* (non-Javadoc)
+  	 * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#setIdInVocabulary(java.lang.String)
+  	 */
+  	@Override
+  	public void setIdInVocabulary(String idInVocabulary) {
+  		this.idInVocabulary = idInVocabulary;
+  	}
+      
+      /* (non-Javadoc)
+       * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getKindOf()
+       */
+      public T getKindOf(){
+          return (T)DefinedTermBase.deproxy(this.kindOf, this.getClass());
+      }
+
+      public void setKindOf(T kindOf){
+          this.kindOf = kindOf;
+      }
+
+
+      @Override
+      public Set<T> getGeneralizationOf(){
+          return this.generalizationOf;
+      }
+
+      protected void setGeneralizationOf(Set<T> value) {
+          this.generalizationOf = value;
+      }
+
+      public void addGeneralizationOf(T generalization) {
+          generalization.setKindOf(this);
+          this.generalizationOf.add(generalization);
+      }
+
+      /* (non-Javadoc)
+       * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#removeGeneralization(T)
+       */
+      public void removeGeneralization(T generalization) {
+          if(generalizationOf.contains(generalization)){
+              generalization.setKindOf(null);
+              this.generalizationOf.remove(generalization);
+          }
+      }
+
+      @Override
+      public T getPartOf(){
+          return (T)DefinedTermBase.deproxy(this.partOf, this.getClass());
+      }
+
+      /**
+       * @see #getPartOf()
+      */
+      public void setPartOf(T partOf){
+          this.partOf = partOf;
+      }
+
+      @Override
+      public Set<T> getIncludes(){
+          return this.includes;
+      }
+
+      /**
+       * @see #getIncludes()
+      */
+      protected void setIncludes(Set<T> includes) {
+          this.includes = includes;
+      }
+
+      /**
+       * @see #getIncludes()
+       */
+      public void addIncludes(T includes) {
+          includes.setPartOf(this);
+          this.includes.add(includes);
+      }
+      
+      /**
+       * @see #getIncludes()
+       */
+      public void removeIncludes(T includes) {
+          if(this.includes.contains(includes)) {
+              includes.setPartOf(null);
+              this.includes.remove(includes);
+          }
+      }
+
+      @Override
+      public Set<Media> getMedia(){
+          return this.media;
+      }
+
+      public void addMedia(Media media) {
+          this.media.add(media);
+      }
+      public void removeMedia(Media media) {
+          this.media.remove(media);
+      }
+
+      /**
+       * @return
+       */
+      public TermVocabulary<T> getVocabulary() {
+          return this.vocabulary;
+      }
+
+      //for bedirectional use only, use vocabulary.addTerm instead
+      /**
+       * @param newVocabulary
+       */
+      protected void setVocabulary(TermVocabulary<T> newVocabulary) {
+          this.vocabulary = newVocabulary;
+    }
+
+//******************************* METHODS ******************************************************/
+   
+
+  	@Override
+  	public boolean isKindOf(T ancestor) {
+  		if (kindOf == null || ancestor == null){
+			return false;
+		}else if (kindOf.equals(ancestor)){
+			return true;
+		}else{
+			return kindOf.isKindOf(ancestor);
+		}
+  	}
+
+  	@Override
+  	public Set<T> getGeneralizationOf(boolean recursive) {
+  		Set<T> result = new HashSet<T>();
+		result.addAll(this.generalizationOf);
+		if (recursive){
+			for (T child : this.generalizationOf){
+				result.addAll(child.getGeneralizationOf());
+			}
+		}
+		return result;
+  	}
+  
+      
+    
     public abstract void resetTerms();
 
     protected abstract void setDefaultTerms(TermVocabulary<T> termVocabulary);
 
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.ILoadableTerm#readCsvLine(java.util.List)
-     */
-    public T readCsvLine(Class<T> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms) {
+    @Override
+    public T readCsvLine(Class<T> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms, boolean abbrevAsId) {
         try {
-            T newInstance = termClass.newInstance();
-            return readCsvLine(newInstance, csvLine, Language.CSV_LANGUAGE());
+            T newInstance = getInstance(termClass);
+            readCsvLine(newInstance, csvLine, Language.CSV_LANGUAGE(), abbrevAsId);
+            readIsPartOf(newInstance, csvLine, terms);
+            return newInstance;
         } catch (Exception e) {
             logger.error(e);
             for(StackTraceElement ste : e.getStackTrace()) {
                 logger.error(ste);
             }
+            throw new RuntimeException(e);
         }
-
-        return null;
     }
-
-    protected static <TERM extends DefinedTermBase> TERM readCsvLine(TERM newInstance, List<String> csvLine, Language lang) {
-            newInstance.setUuid(UUID.fromString(csvLine.get(0)));
-            newInstance.setUri( URI.create(csvLine.get(1)));
-            String label = csvLine.get(2).trim();
-            String text = csvLine.get(3);
-            String abbreviatedLabel = csvLine.get(4);
-            newInstance.addRepresentation(Representation.NewInstance(text, label, abbreviatedLabel, lang) );
-            return newInstance;
+    
+	protected static <TERM extends DefinedTermBase> TERM readCsvLine(TERM newInstance, List<String> csvLine, Language lang, boolean abbrevAsId) {
+        newInstance.setUuid(UUID.fromString(csvLine.get(0)));
+        newInstance.setUri( URI.create(csvLine.get(1)));
+        String label = csvLine.get(2).trim();
+        String description = csvLine.get(3);
+        String abbreviatedLabel = csvLine.get(4);
+        if (StringUtils.isBlank(abbreviatedLabel)){
+        	abbreviatedLabel = null;
+        }
+        if (abbrevAsId){
+        	newInstance.setIdInVocabulary(abbreviatedLabel);  //new in 3.3
+        }
+        newInstance.addRepresentation(Representation.NewInstance(description, label, abbreviatedLabel, lang) );
+        
+        return newInstance;
     }
+    
+    protected void readIsPartOf(T newInstance, List<String> csvLine, Map<UUID, DefinedTermBase> terms){
+        int index = partOfCsvLineIndex();
+ 		if (index != -1){
+	        String partOfString = csvLine.get(index);
+	         if(StringUtils.isNotBlank(partOfString)) {
+	             UUID partOfUuid = UUID.fromString(partOfString);
+	             DefinedTermBase partOf = (DefinedTermBase)terms.get(partOfUuid);
+	             partOf.addIncludes(newInstance);
+	         }
+ 		}
+ 	
+    }
+    
+	/**
+	 * Get the 
+	 * @return
+	 */
+	protected int partOfCsvLineIndex() {
+		return -1;
+	}
+
+
+	private  <T extends DefinedTermBase> T getInstance(Class<? extends DefinedTermBase> termClass) {
+		try {
+			Constructor<T> c = ((Class<T>)termClass).getDeclaredConstructor();
+			c.setAccessible(true);
+			T termInstance = c.newInstance();
+			return termInstance;
+		} catch (Exception e) {
+			throw new RuntimeException(e);
+		}
+	}
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.ILoadableTerm#writeCsvLine(au.com.bytecode.opencsv.CSVWriter)
-     */
+    @Override
     public void writeCsvLine(CSVWriter writer, T term) {
         String [] line = new String[4];
         line[0] = term.getUuid().toString();
@@ -209,127 +409,11 @@ public abstract class DefinedTermBase<T extends DefinedTermBase> extends TermBas
         writer.writeNext(line);
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getByUuid(java.util.UUID)
-     */
     @Transient
     public T getByUuid(UUID uuid){
         return this.vocabulary.findTermByUuid(uuid);
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getKindOf()
-     */
-    public T getKindOf(){
-        return (T)DefinedTermBase.deproxy(this.kindOf, this.getClass());
-    }
-
-    public void setKindOf(T kindOf){
-        this.kindOf = kindOf;
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getGeneralizationOf()
-     */
-    public Set<T> getGeneralizationOf(){
-        return this.generalizationOf;
-    }
-
-    protected void setGeneralizationOf(Set<T> value) {
-        this.generalizationOf = value;
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#addGeneralizationOf(T)
-     */
-    public void addGeneralizationOf(T generalization) {
-        generalization.setKindOf(this);
-        this.generalizationOf.add(generalization);
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#removeGeneralization(T)
-     */
-    public void removeGeneralization(T generalization) {
-        if(generalizationOf.contains(generalization)){
-            generalization.setKindOf(null);
-            this.generalizationOf.remove(generalization);
-        }
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getPartOf()
-     */
-    public T getPartOf(){
-        return (T)DefinedTermBase.deproxy(this.partOf, this.getClass());
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#setPartOf(T)
-     */
-    public void setPartOf(T partOf){
-        this.partOf = partOf;
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getIncludes()
-     */
-    public Set<T> getIncludes(){
-        return this.includes;
-    }
-
-    protected void setIncludes(Set<T> includes) {
-        this.includes = includes;
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#addIncludes(T)
-     */
-    public void addIncludes(T includes) {
-        includes.setPartOf(this);
-        this.includes.add(includes);
-    }
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#removeIncludes(T)
-     */
-    public void removeIncludes(T includes) {
-        if(this.includes.contains(includes)) {
-            includes.setPartOf(null);
-            this.includes.remove(includes);
-        }
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#getMedia()
-     */
-    public Set<Media> getMedia(){
-        return this.media;
-    }
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.common.IDefinedTerm#addMedia(eu.etaxonomy.cdm.model.media.Media)
-     */
-    public void addMedia(Media media) {
-        this.media.add(media);
-    }
-    public void removeMedia(Media media) {
-        this.media.remove(media);
-    }
-
-    /**
-     * @return
-     */
-    public TermVocabulary<T> getVocabulary() {
-        return this.vocabulary;
-    }
-
-    //for bedirectional use only, use vocabulary.addTerm instead
-    /**
-     * @param newVocabulary
-     */
-    protected void setVocabulary(TermVocabulary<T> newVocabulary) {
-        this.vocabulary = newVocabulary;
-    }
 
 //*********************** CLONE ********************************************************/
 
@@ -369,10 +453,7 @@ public abstract class DefinedTermBase<T extends DefinedTermBase> extends TermBas
             result.addMedia(media);
         }
 
-
-
-
         return result;
-
     }
+
 }
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EnumeratedTermVoc.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EnumeratedTermVoc.java
new file mode 100644
index 0000000000..8c0ec7c414
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EnumeratedTermVoc.java
@@ -0,0 +1,191 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.model.common;
+
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+import java.util.UUID;
+
+/**
+ * @author a.mueller
+ *
+ */
+public class EnumeratedTermVoc<T extends IEnumTerm<T>> {
+
+	private static Map<Class<? extends IEnumTerm<?>>,EnumeratedTermVoc<?>> vocsMap= new HashMap<Class<? extends IEnumTerm<?>>, EnumeratedTermVoc<?>>();
+	
+	private final Map<T,SingleEnumTerm<T>> lookup = new HashMap<T, SingleEnumTerm<T>>();
+	
+//	public interface EnumTerm<R extends EnumTerm<?>> extends ISimpleTerm<R>{
+//		public String getKey();
+//	}
+	
+	private class SingleEnumTerm<S extends T> implements IEnumTerm<T>{
+		private S term;
+		private String label;
+		private UUID uuid;
+		private String key;
+		private Set<S> children = new HashSet<S>();
+		private S parent;
+
+
+		
+		private	SingleEnumTerm(S term, UUID uuid, String defaultString, String key, S parent){
+			this.term = term;
+			this.label = defaultString;
+			this.key = key;
+			this.uuid = uuid;
+			this.parent = parent;
+			SingleEnumTerm<T> parentSingleEnum = lookup.get(parent); 
+			if (parentSingleEnum != null){
+				parentSingleEnum.children.add(term);
+			}
+		}
+		
+		@Override
+		public UUID getUuid() {	return uuid;}
+		@Override
+		public T getKindOf() {return parent;}
+		public T getTerm() {return term;}
+		@Override
+		public String getKey() {return key;	}
+
+		@Override
+		public String getMessage() {return getMessage(Language.DEFAULT());}
+
+		@Override
+		public String getMessage(Language language) {
+			//TODO make multi-lingual
+			return label;
+		}
+		
+		@Override
+		public Set<T> getGeneralizationOf() {
+//			return Collections.unmodifiableSet( children );   //TODO creates stack overflow
+			return new HashSet<T>(children);
+		}
+
+		@Override
+		public boolean isKindOf(T ancestor) {
+			if (parent == null || ancestor == null){
+				return false;
+			}else if (parent.equals(ancestor)){
+				return true;
+			}else{
+				return parent.isKindOf(ancestor);
+			}
+		}
+
+		@Override
+		public Set<T> getGeneralizationOf(boolean recursive) {
+			Set<T> result = new HashSet<T>();
+			result.addAll(this.children);
+			if (recursive){
+				for (T child : this.children){
+					result.addAll(child.getGeneralizationOf());
+				}
+			}
+			return result;
+		}
+
+	} //end of inner class
+
+//******************* DELEGATE NETHODS ************************
+
+	public String getKey(T term) {return lookup.get(term).getKey();}
+
+	public UUID getUuid(T term) {return lookup.get(term).getUuid();}
+	
+	public T getKindOf(T term) {return lookup.get(term).getKindOf();}
+
+	public Set<T> getGeneralizationOf(T term) {return lookup.get(term).getGeneralizationOf();}
+
+//******************* DELEGATE CLASS NETHODS ************************
+
+	
+	public static <S extends IEnumTerm<?>> IEnumTerm addTerm(Class<? extends IEnumTerm<?>> clazz, S term, UUID uuid, String defaultString, String key, S parent){
+		if (vocsMap.get(clazz) == null){
+			vocsMap.put(clazz, new EnumeratedTermVoc());
+		}
+		IEnumTerm myTerm = vocsMap.get(clazz).add(term, uuid, defaultString, key, parent);
+		return myTerm;
+	}
+	
+	private  SingleEnumTerm<T> add(ISimpleTerm<?> term, UUID uuid, String defaultString, String key, ISimpleTerm<?> parent) {
+		SingleEnumTerm<T> singleTerm = new SingleEnumTerm<T>((T)term, uuid, defaultString, key, (T)parent);
+		if (containsKey(lookup, key)){
+			throw new RuntimeException(String.format("Key must be unique in enumeration but was not for '%s'", key));
+		}
+		if (containsUuid(lookup, uuid)){
+			throw new RuntimeException(String.format("UUID must be unique in enumeration but was not for '%s'", uuid));
+		}
+		lookup.put((T)term, singleTerm);
+		return singleTerm;
+	}
+
+	public boolean containsKey(Map<T, SingleEnumTerm<T>> lookup, String key) {
+		for (SingleEnumTerm<T> term : lookup.values()){
+			if (term.getKey().equals(key)){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public boolean containsUuid(Map<T, SingleEnumTerm<T>> lookup, UUID uuid) {
+		for (SingleEnumTerm<T> term : lookup.values()){
+			if (term.getUuid().equals(uuid)){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public static <R extends IEnumTerm<R>> R byKey(Class<R> clazz, String key) {
+		EnumeratedTermVoc<R> voc = getVoc(clazz);
+		return voc == null? null:voc.getByKey(key);
+	}
+
+	public static <R extends IEnumTerm<R>> R byUuid(Class<R> clazz, UUID uuid) {
+		EnumeratedTermVoc<R> voc = getVoc(clazz);
+		return voc == null? null:voc.getByUuid(uuid);
+	}
+
+	
+	public T getByKey(String key) {
+		for (SingleEnumTerm<T> term : lookup.values()){
+			if (term.getKey().equals(key)){
+				return term.getTerm();
+			}
+		}
+		return null;
+	}
+	
+	public T getByUuid(UUID uuid) {
+		for (SingleEnumTerm<T> term : lookup.values()){
+			if (term.getUuid().equals(uuid)){
+				return term.getTerm();
+			}
+		}
+		return null;
+	}
+
+	public static <R extends IEnumTerm<R>> EnumeratedTermVoc<R> getVoc(Class<R> clazz) {
+		return (EnumeratedTermVoc<R>)vocsMap.get(clazz);
+	}
+
+
+
+	
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EventBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EventBase.java
index 0e2467a1a3..e1445740b3 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EventBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/EventBase.java
@@ -53,50 +53,46 @@ public abstract class EventBase extends AnnotatableEntity implements IEvent {
 	@ManyToOne(fetch = FetchType.LAZY)
 	@IndexedEmbedded
 	@Cascade(CascadeType.SAVE_UPDATE)
-	private AgentBase actor;
+	private AgentBase<?> actor;
 
 	@XmlElement(name = "Description")
 	@Field(index=Index.YES)
 	private String description;
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#getTimeperiod()
-	 */
+//******************** GETTER / SETTER *******************/	
+	
 	@Override
     public TimePeriod getTimeperiod() {
 		return timeperiod;
 	}
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#setTimeperiod(eu.etaxonomy.cdm.model.common.TimePeriod)
-	 */
 	@Override
     public void setTimeperiod(TimePeriod timeperiod) {
+		if (timeperiod == null){
+			timeperiod = TimePeriod.NewInstance();
+		}
 		this.timeperiod = timeperiod;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#getActor()
-	 */
 	@Override
     public AgentBase getActor() {
 		return actor;
 	}
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#setActor(eu.etaxonomy.cdm.model.agent.Agent)
-	 */
 	@Override
     public void setActor(AgentBase actor) {
 		this.actor = actor;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#getDescription()
+	/**
+	 * The description of this event. Implementing classes may use this field for different purposes.
+	 * @return
 	 */
 	public String getDescription() {
 		return description;
 	}
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.model.occurrence.IEvent#setDescription(java.lang.String)
+
+	/**
+	 * @see #getDescription()
+	 * @param description
 	 */
 	public void setDescription(String description) {
 		this.description = description;
@@ -117,7 +113,7 @@ public abstract class EventBase extends AnnotatableEntity implements IEvent {
 	@Override
 	public Object clone() throws CloneNotSupportedException{
 		EventBase result = (EventBase)super.clone();
-		//Actor
+		//Actor  //is this needed??
 		result.setActor(this.getActor());
 		//time period
 		result.setTimeperiod((TimePeriod)this.getTimeperiod().clone());
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ExtensionType.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ExtensionType.java
index 078b7e56a3..08248ce311 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ExtensionType.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ExtensionType.java
@@ -30,7 +30,6 @@ import org.hibernate.search.annotations.Indexed;
  * types, but rather content types like "DOI", "2nd nomenclatural reference", "3rd
  * hybrid parent" or specific local identifiers.
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:23
  */
 @XmlAccessorType(XmlAccessType.FIELD)
@@ -84,9 +83,10 @@ public class ExtensionType extends DefinedTermBase<ExtensionType> {
 
 //********************************** Constructor *******************************************************************/	
 	
-	//public only for Term Loader
+	//for hibernate use only
 	@Deprecated
-	public ExtensionType() {
+	protected ExtensionType() {
+		super(TermType.ExtensionType);
 	}
 	
 	/** 
@@ -101,7 +101,7 @@ public class ExtensionType extends DefinedTermBase<ExtensionType> {
 	 * @see 				 #ExtensionType()
 	 */
 	protected ExtensionType(String term, String label, String labelAbbrev) {
-		super(term, label, labelAbbrev);
+		super(TermType.ExtensionType, term, label, labelAbbrev);
 	}
 
 //************************** METHODS *******************************************************/
